package transactionFeature;

import com.sleepycat.je.DatabaseConfig;

privileged public aspect DatabaseConfigRef {
	
	private boolean txnMatch(DatabaseConfig configParam, DatabaseConfig configThis){
		if (configParam == null) {
			configParam = DatabaseConfig.DEFAULT;
		}
		return configParam.getTransactional() == configThis.transactional;
	}
	
	before(StringBuffer ret, DatabaseConfig configParam, DatabaseConfig configThis) : 
		call(void DatabaseConfig.hook_checkTransactional(StringBuffer)) && args(ret) &&
		cflow(execution(* DatabaseConfig.validate(DatabaseConfig)) && args(configParam)) &&
		this(configThis)
	{
		
		if (!txnMatch(configParam,configThis)) {
			ret.append(" Transactional\n");
		}
	}
	
	boolean around(DatabaseConfig configParam, DatabaseConfig configThis) : 
		call(boolean DatabaseConfig.hook_checkValid(boolean,boolean,boolean,boolean)) &&
		cflow(execution(* DatabaseConfig.validate(DatabaseConfig)) && args(configParam)) &&
		this(configThis)
	{
		return proceed(configParam, configThis) && txnMatch(configParam,configThis);
	}
	
	
}
