package transactionFeature;

import com.sleepycat.je.Database;
import com.sleepycat.je.DatabaseEntry;
import com.sleepycat.je.OperationContext;
import com.sleepycat.je.Sequence;
import com.sleepycat.je.SequenceConfig;
import com.sleepycat.je.TransactionConfig;

public aspect SequenceAutoCommitConfig {
	private TransactionConfig Sequence.autoCommitConfig;

	before(Sequence sq, SequenceConfig config) : 
		execution(Sequence.new(Database, OperationContext, DatabaseEntry, SequenceConfig)) && 
		args(Database, OperationContext, DatabaseEntry,config) && this(sq) 
	{
		if (config.getAutoCommitNoSync()) {
			sq.autoCommitConfig = new TransactionConfig();
			sq.autoCommitConfig.setNoSync(true);
		} else {
			/* Use the environment's default transaction config. */
			sq.autoCommitConfig = null;
		}
	}
}
