package transactionFeature;

import com.sleepycat.bind.serial.StoredClassCatalog;
import com.sleepycat.je.Cursor;
import com.sleepycat.je.CursorConfig;
import com.sleepycat.je.Database;
import com.sleepycat.je.DatabaseException;
import com.sleepycat.je.OperationContext;

privileged public aspect StoredClassCatalogPutClassInfo 
	percflow(execution(* StoredClassCatalog.putClassInfo(..))) {

	private Transaction txn = null;

	Cursor around(StoredClassCatalog scc, Database db, CursorConfig cursorConfig)
			throws DatabaseException: 
		call(Cursor Database.openCursor(OperationContext, CursorConfig)) && 
		args(OperationContext, cursorConfig) && this(scc) && target(db)
	{
		if (scc.txnMode) {
			txn = db.getEnvironment().beginTransaction(null, null);
		}
		return db.openCursor(txn, cursorConfig);
	}

	after() throws DatabaseException:
		call(void StoredClassCatalog.hook_commitTransaction())
	{
		if (txn != null) {
			txn.commit();
		}
	}
}
