package transactionFeature;

import com.sleepycat.bind.serial.StoredClassCatalog;
import com.sleepycat.je.Cursor;
import com.sleepycat.je.CursorConfig;
import com.sleepycat.je.Database;
import com.sleepycat.je.DatabaseException;
import com.sleepycat.je.EnvironmentConfig;
import com.sleepycat.je.LockMode;

privileged public aspect StoredClassCatalogRef {

	LockMode around(EnvironmentConfig envConfig) : 
		call(LockMode StoredClassCatalog.hook_getLockMode(EnvironmentConfig)) && args(envConfig) 
	{
		if (envConfig.getTransactional())
			return LockMode.RMW;
		return proceed(envConfig);
	}

	private boolean StoredClassCatalog.txnMode;

	after(StoredClassCatalog scc) throws DatabaseException:
		call(LockMode StoredClassCatalog.hook_getLockMode(EnvironmentConfig)) && this(scc)
	{
		scc.txnMode = scc.db.getConfig().getTransactional();
	}



}
