package transactionFeature;

import com.sleepycat.compat.DbCompat;
import com.sleepycat.je.DatabaseException;
import com.sleepycat.je.DbInternal;
import com.sleepycat.je.Environment;
import com.sleepycat.je.txn.Locker;
import com.sleepycat.je.txn.TxnManager;

privileged public aspect TransactionObjects {
	/**
	 * Proxy to Transaction.getLocker()
	 */
	public static Locker DbInternal.getLocker(Transaction txn)
			throws DatabaseException {

		return txn.getLocker();
	}

	/**
	 * Javadoc for this public method is generated via the doc templates in the
	 * doc_src directory.
	 */
	public Transaction Environment.getThreadTransaction()
			throws DatabaseException {

		return (Transaction) environmentImpl.getTxnManager().getTxnForThread();
	}

	/**
	 * Javadoc for this public method is generated via the doc templates in the
	 * doc_src directory.
	 */
	public void Environment.setThreadTransaction(Transaction txn) {

		environmentImpl.getTxnManager().setTxnForThread(txn);
	}

	/**
	 * Called when txn is assoc'd with this thread.
	 */
	public void TxnManager.setTxnForThread(Transaction txn) {

		Thread curThread = Thread.currentThread();
		thread2Txn.put(curThread, txn);
	}

	/**
	 * Called when txn is assoc'd with this thread.
	 */
	public Transaction TxnManager.unsetTxnForThread() throws DatabaseException {

		Thread curThread = Thread.currentThread();
		return (Transaction) thread2Txn.remove(curThread);
	}

	/**
	 * Retrieve a Txn object for this Thread.
	 */
	public Transaction TxnManager.getTxnForThread() throws DatabaseException {

		return (Transaction) thread2Txn.get(Thread.currentThread());
	}

	/*
	 * misc
	 */
	public static Transaction DbCompat.getThreadTransaction(Environment env)
			throws DatabaseException {
		return env.getThreadTransaction();
	}

}
